/**
 * 
 */
#ifdef DEBUG
#	define isCHECBOX(widget) (assert(widget->type == CHECKBOX));
#else
#	define isCHECBOX(widget)
#endif

#include "CheckBox.colors"

/** @brief Przecznik.
 *
 *
 */
typedef struct uiCheckBox {
	checkbox_callback callback;	/**< funkcja wywoywana przy zmianie stanu przecznika */
	GLboolean state;		/**< */
	char* label;

	GLenum halign;
	GLenum valign;
} uiCheckBox;

static void checkbox_draw(pWidget widget, GLint dx, GLint dy) {
	uiCheckBox* checkbox;

	if (widget->visible == GL_FALSE) return;

	checkbox = (uiCheckBox*)widget->extra;
	if (widget->active)
		switch (checkbox->state) {
			case GL_TRUE:
				draw_button_face(widget->x + dx, widget->y + dy, widget->w, widget->h, checkbox->label, checkbox->halign, checkbox->valign, checkbox_back_active_on, checkbox_text_active);
				break;
			case GL_FALSE:
				draw_button_face(widget->x + dx, widget->y + dy, widget->w, widget->h, checkbox->label, checkbox->halign, checkbox->valign, checkbox_back_active_off, checkbox_text_active);
				break;
	}
	else
		switch (checkbox->state) {
			case GL_TRUE:
				draw_button_face(widget->x + dx, widget->y + dy, widget->w, widget->h, checkbox->label, checkbox->halign, checkbox->valign, checkbox_back_inactive_on, checkbox_text_inactive);
				break;
			case GL_FALSE:
				draw_button_face(widget->x + dx, widget->y + dy, widget->w, widget->h, checkbox->label, checkbox->halign, checkbox->valign, checkbox_back_inactive_off, checkbox_text_inactive);
				break;
		}
}

static void checkbox_activate(pWidget widget, GLint x, GLint y) {
	uiCheckBox* checkbox;

	isCHECBOX(widget);
	checkbox = (uiCheckBox*)widget->extra;

	if (widget->active) {
		checkbox->state = (checkbox->state == GL_FALSE) ? GL_TRUE : GL_FALSE;
		if (checkbox->callback)
			checkbox->callback(widget, checkbox->state);
	}
}

pWidget uiNewCheckBox(pWidget widget, checkbox_callback callback, const char* label, GLenum halign, GLenum valign) {
	uiCheckBox* new;
	
	new = (uiCheckBox*)malloc(sizeof(uiCheckBox));
	new->callback		= callback;
	new->state		= GL_FALSE;
	new->label		= mystrdup(label);
	new->halign		= SetOption3(halign, ALIGN_CENTER, ALIGN_LEFT, ALIGN_RIGHT);
	new->valign		= SetOption3(valign, ALIGN_CENTER, ALIGN_TOP, ALIGN_BOTTOM);

	
	widget->mbp		= &checkbox_activate;
	widget->draw		= &checkbox_draw;
	widget->extra		= (void*)new;
	widget->type		= CHECKBOX;
	
	return widget;
}

GLboolean uiCheckBoxGetState(pWidget widget) {
	isCHECBOX(widget);
	return ((uiCheckBox*)widget->extra)->state;
}

void uiCheckBoxSetState(pWidget widget, GLboolean state) {
	isCHECBOX(widget);
	((uiCheckBox*)widget->extra)->state = (state ? GL_TRUE : GL_FALSE);
}
