#ifdef DEBUG
#	define isCONTAINER(widget) (assert(widget->type == CONTAINER));
#else
#	define isCONTAINER(widget)
#endif

typedef struct uiContainer {
	GLuint n;
	pWidget *children;
} uiContainer;

static void container_activate(pWidget widget, GLint x, GLint y) {
	isCONTAINER(widget);
}

static void container_draw(pWidget widget, GLint dx, GLint dy) {
	uiContainer* container;
	GLuint i;
	DECLARE_GRAYA(c, 1.0, 0.2);

	isCONTAINER(widget);
	
	if (widget->visible == GL_FALSE) return;

	draw_rectangle(widget->x, widget->y, widget->w, widget->h, c);

	container = (uiContainer*)widget->extra;
	for (i=0; i < container->n; i++)
		if (container->children[i]->draw)
			container->children[i]->draw(container->children[i], widget->x + dx, widget->y + dy);
}

pWidget uiNewContainer(pWidget widget, ...) {
	uiContainer*	new;
	GLuint		n, i;
	va_list		ap;


	new = (uiContainer*)malloc(sizeof(uiContainer));
	assert(new != NULL);

	/* count optional arguments */
	va_start(ap, widget);
	n = 0;
	while (va_arg(ap, pWidget) != NULL)
		n++;
	va_end(ap);

	/* allcoate space for children */
	new->n		= n;
	new->children	= (pWidget*)malloc(sizeof(pWidget) * n);
	assert(new->children != NULL);

	va_start(ap, widget);
	for (i=0; i<n; i++)
		new->children[i] = va_arg(ap, pWidget);
	va_end(ap);

	widget->draw		= &container_draw;
	widget->mbp		= &container_activate;
	widget->extra		= (void*)new;
	widget->type		= CONTAINER;

	return widget;
}
