#ifdef DEBUG
#	define isLABEL(widget) (assert(widget->type == LABEL));
#else
#	define isLABEL(widget)
#endif

typedef struct uiLabelRef {
	const char*	line;
	GLenum	halign;
	GLfloat	textcolor[4];
} uiLabelRef;

static void labelref_draw(pWidget widget, GLint dx, GLint dy) {
	uiLabelRef	*label;
	label = (uiLabelRef*)widget->extra;
	draw_aligned_string(widget->x + dx, widget->y + dy, widget->w, widget->h, label->line, label->halign, ALIGN_BOTTOM, label->textcolor);
}

pWidget uiNewLabelRef(pWidget widget, GLenum halign, GLfloat r, GLfloat g, GLfloat b, const char* strptr) {
	uiLabelRef*	new;

	new = (uiLabelRef*)malloc(sizeof(uiLabel));
	assert(new != NULL);
	
	new->halign		= SetOption3(halign, ALIGN_CENTER, ALIGN_LEFT, ALIGN_RIGHT);
	new->textcolor[0]	= clampf(r, 0.0, 1.0);
	new->textcolor[1]	= clampf(g, 0.0, 1.0);
	new->textcolor[2]	= clampf(b, 0.0, 1.0);
	new->textcolor[3]	= 1.0;
	new->line		= strptr;

	widget->draw		= &labelref_draw;
	widget->extra		= (void*)new;
	widget->type		= LABEL;

	return widget;
}	
