#include <math.h>
#include <stdlib.h>
#include <GL/glut.h>

#include "gui.h"

int window;

pWidget b1, b2, sw, rd, axis, f, sr, sg, sb, info;

void b1c(pWidget _) {
	uiDeactive(rd);
	uiDeactive(sr);
	uiDeactive(sg);
	uiDeactive(sb);
	puts("button one");
}

void b2c(pWidget _) {
	uiActive(rd);
	uiActive(sr);
	uiActive(sg);
	uiActive(sb);
	puts("button two");
}

void value(pWidget _, GLint x) {
	printf("current value is %d\n", x);
}

void value2(pWidget _, GLuint x) {
	printf("current value is %d\n", x);
}

void makegui(GLuint width, GLuint height) {
	b1 = uiNewButton(uiNewWidget(0x01, 10, 10, 200, 30), &b1c, "disable", ALIGN_CENTER, ALIGN_CENTER);
	b2 = uiNewButton(uiNewWidget(0x02, 10, 50, 200, 30), &b2c, "enable", ALIGN_CENTER, ALIGN_CENTER);
	sw = uiNewCheckBox(uiNewWidget(0x00, 10, 300, 200, 25), NULL, "Light0", ALIGN_CENTER, ALIGN_CENTER);
	rd = uiNewRadioButtons(uiNewWidget(0x00, 10, 100, 200, 5*25), value2, ALIGN_CENTER, ALIGN_CENTER, RADIOBUTTONS_VERTICAL, "Linux", "does", "it", "much", "better", NULL);
	axis = uiNewRadioButtons(uiNewWidget(0x00, 10, 100+5*25+10, 200, 30), value2, ALIGN_CENTER, ALIGN_CENTER, RADIOBUTTONS_HORIZONTAL, "X", "Y", "Z", NULL);

	//si = uiNewISlider(uiNewWidget(0x00, 20, 350, 350, 20), &value, 30, 0, 100, SLIDER_HORIZONTAL);
	
	sr = uiNewFSlider(uiNewWidget(0x00, 220, 50, 30, 250), &value, 30, 0, 100, SLIDER_VERTICAL, 1, 0, 0);
	sg = uiNewFSlider(uiNewWidget(0x00, 260, 50, 30, 250), &value, 30, 0, 100, SLIDER_VERTICAL, 0, 1, 0);
	sb = uiNewFSlider(uiNewWidget(0x00, 300, 50, 30, 250), &value, 30, 0, 100, SLIDER_VERTICAL, 0, 0, 1);

	info = uiNewLabel(uiNewWidget(0, 30, 350, 300, 300), ALIGN_RIGHT, 22, 1.0, 1.0, 1.0, "This is a sample", "of OpenGL GUI", NULL);

	f = uiNewContainer(uiNewWidget(0x00, 30, 30, 400, 400), b1, b2, sw, rd, axis, sr, sg, sb, info, NULL);
	InitGUI(width, height, f, NULL);
		
}

void glutClick(int button, int state, int x, int y) {
	if (state == GLUT_DOWN && button == GLUT_LEFT)
		ClickGUI(x,y);
}

void draw(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	DrawGUI();
	glutSwapBuffers();
}

void keys(unsigned char key, int x, int y) {
	static GLfloat angle_incr = 5;
	switch (key) {
		case 27:
		case 'q':
			DestroyGUI();
			glutDestroyWindow(window);
			break;
		case 'h':
		case 'H':
			HideGUI();
			break;
		
		case 's':
		case 'S':
			ShowGUI();
			break;
	}
}

void reshape(int w, int h) {
	ReshapeGUI(w,h);
	uiCenterWidget(f);
}

int main(int argc, char* argv[]) {
	int size = 400;
	
	glutInit(&argc, argv);
	makegui(size, size);
	ShowGUI();
	// ustawienie rodzaju okna: kolory RGB(A), podwjne buforowanie
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH | GLUT_ALPHA);

	// ustawienie rozmiaru okna
	glutInitWindowSize(size, size);

	// utworzenie okna
	window = glutCreateWindow("Test GUIGL");

	// callbacks
	glutDisplayFunc(draw);		// funkcja rysujca
	glutIdleFunc(draw);		// funkcja rysujca
	glutKeyboardFunc(keys);		// obsuga klawiszy
	glutMouseFunc(glutClick);	// reakcja na kliknicia myszk
	glutReshapeFunc(reshape);	// reakcja na zmian rozmiaru okna

	// Funkcje OGL
	//glEnable(GL_DEPTH_TEST);	// wczenie Z-bufora
	glEnable(GL_SCISSOR_TEST);

	glScissor(50,100, 400, 200);

	// gwna ptla - przetwrzanie komunikatw
	glutMainLoop();
	DestroyGUI();
	return 0;
}

// vim: ts=8
